Index: /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.Designer.cs	(revision 435)
+++ /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.Designer.cs	(revision 436)
@@ -47,17 +47,17 @@
       this.groupBox = new System.Windows.Forms.GroupBox();
       this.listView = new System.Windows.Forms.ListView();
-      this.panel = new System.Windows.Forms.Panel();
       this.removeButton = new System.Windows.Forms.Button();
       this.groupBox.SuspendLayout();
-      this.panel.SuspendLayout();
       this.SuspendLayout();
       // 
       // groupBox
       // 
+      this.groupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBox.Controls.Add(this.listView);
-      this.groupBox.Dock = System.Windows.Forms.DockStyle.Top;
       this.groupBox.Location = new System.Drawing.Point(0, 0);
       this.groupBox.Name = "groupBox";
-      this.groupBox.Size = new System.Drawing.Size(463, 285);
+      this.groupBox.Size = new System.Drawing.Size(463, 305);
       this.groupBox.TabIndex = 0;
       this.groupBox.TabStop = false;
@@ -70,5 +70,5 @@
       this.listView.Location = new System.Drawing.Point(3, 16);
       this.listView.Name = "listView";
-      this.listView.Size = new System.Drawing.Size(457, 266);
+      this.listView.Size = new System.Drawing.Size(457, 286);
       this.listView.TabIndex = 1;
       this.listView.UseCompatibleStateImageBehavior = false;
@@ -80,16 +80,8 @@
       this.listView.DragOver += new System.Windows.Forms.DragEventHandler(this.listView_DragOver);
       // 
-      // panel
-      // 
-      this.panel.Controls.Add(this.removeButton);
-      this.panel.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.panel.Location = new System.Drawing.Point(0, 291);
-      this.panel.Name = "panel";
-      this.panel.Size = new System.Drawing.Size(463, 46);
-      this.panel.TabIndex = 1;
-      // 
       // removeButton
       // 
-      this.removeButton.Location = new System.Drawing.Point(3, 3);
+      this.removeButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.removeButton.Location = new System.Drawing.Point(3, 311);
       this.removeButton.Name = "removeButton";
       this.removeButton.Size = new System.Drawing.Size(75, 23);
@@ -103,10 +95,9 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.panel);
+      this.Controls.Add(this.removeButton);
       this.Controls.Add(this.groupBox);
       this.Name = "AllSubOperatorsTypeConstraintView";
       this.Size = new System.Drawing.Size(463, 337);
       this.groupBox.ResumeLayout(false);
-      this.panel.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -116,5 +107,4 @@
 
     private System.Windows.Forms.GroupBox groupBox;
-    private System.Windows.Forms.Panel panel;
     private System.Windows.Forms.Button removeButton;
     private System.Windows.Forms.ListView listView;
Index: /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.cs	(revision 435)
+++ /trunk/sources/HeuristicLab.Constraints/AllSubOperatorsTypeConstraintView.cs	(revision 436)
@@ -31,5 +31,5 @@
 namespace HeuristicLab.Constraints {
   public partial class AllSubOperatorsTypeConstraintView : ViewBase {
-    private SubOperatorTypeConstraint constraint;
+    private SubOperatorTypeConstraint constraint = new SubOperatorTypeConstraint();
 
     public SubOperatorTypeConstraint Constraint {
@@ -46,7 +46,6 @@
 
     public AllSubOperatorsTypeConstraintView(SubOperatorTypeConstraint constraint) {
+      this.constraint = constraint;
       InitializeComponent();
-      this.constraint = constraint;
-      UpdateAllowedOperatorsList();
     }
 
Index: /trunk/sources/HeuristicLab.Constraints/SubOperatorsTypeConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/SubOperatorsTypeConstraintView.Designer.cs	(revision 435)
+++ /trunk/sources/HeuristicLab.Constraints/SubOperatorsTypeConstraintView.Designer.cs	(revision 436)
@@ -70,4 +70,7 @@
       // allSubOperatorsTypeConstraintView
       // 
+      this.allSubOperatorsTypeConstraintView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.allSubOperatorsTypeConstraintView.Caption = "View";
       this.allSubOperatorsTypeConstraintView.Location = new System.Drawing.Point(0, 35);