Index: trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLab.Operators.Stopwatch.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLab.Operators.Stopwatch.csproj	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLab.Operators.Stopwatch.csproj	(revision 445)
@@ -0,0 +1,81 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.21022</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{39DEF061-8261-43DB-8B3B-C7555251FF77}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Operators.Stopwatch</RootNamespace>
+    <AssemblyName>HeuristicLab.Operators.Stopwatch</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Xml.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="StopStopwatch.cs" />
+    <Compile Include="StartStopwatch.cs" />
+    <Compile Include="HeuristicLabOperatorsStopwatchPlugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Stopwatch.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Data\HeuristicLab.Data.csproj">
+      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
+      <Name>HeuristicLab.Data</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLabOperatorsStopwatchPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLabOperatorsStopwatchPlugin.cs	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/HeuristicLabOperatorsStopwatchPlugin.cs	(revision 445)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Operators.Stopwatch {
+  [ClassInfo(Name = "HeuristicLab.Operators.Stopwatch")]
+  [PluginFile(Filename = "HeuristicLab.Operators.Stopwatch.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core")]
+  [Dependency(Dependency = "HeuristicLab.Data")]
+  [Dependency(Dependency = "HeuristicLab.Operators")]
+  public class HeuristicLabOperatorsStopwatchPlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.Operators.Stopwatch/Properties/AssemblyInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/Properties/AssemblyInfo.cs	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/Properties/AssemblyInfo.cs	(revision 445)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Operators.Stopwatch")]
+[assembly: AssemblyDescription("Provides operators and data for stop-watch functionality")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("1599bffe-09cb-4c34-8383-2d45e7234514")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.0.0.0")]
+[assembly: AssemblyFileVersion("3.0.0.0")]
Index: trunk/sources/HeuristicLab.Operators.Stopwatch/StartStopwatch.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/StartStopwatch.cs	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/StartStopwatch.cs	(revision 445)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Operators.Stopwatch {
+  public class StartStopWatch : OperatorBase {
+    public override string Description {
+      get { return @"Starts a stopwatch"; }
+    }
+
+    public StartStopWatch()
+      : base() {
+      AddVariableInfo(new VariableInfo("Stopwatch", "Stopwatch", typeof(Stopwatch), VariableKind.In));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      Stopwatch stopWatch = GetVariableValue<Stopwatch>("Stopwatch", scope, true);
+      stopWatch.Start();
+      return null;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Operators.Stopwatch/StopStopwatch.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/StopStopwatch.cs	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/StopStopwatch.cs	(revision 445)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Operators.Stopwatch {
+  public class StopStopWatch : OperatorBase {
+    public override string Description {
+      get { return @"Stops a stopwatch and reads the elapsed seconds"; }
+    }
+
+    public StopStopWatch()
+      : base() {
+      AddVariableInfo(new VariableInfo("Stopwatch", "Stopwatch", typeof(Stopwatch), VariableKind.In));
+      AddVariableInfo(new VariableInfo("ElapsedSeconds", "Elapsed seconds on the stop watch", typeof(DoubleData), VariableKind.Out));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      Stopwatch stopWatch = GetVariableValue<Stopwatch>("Stopwatch", scope, true);
+      stopWatch.Stop();
+      GetVariableValue<DoubleData>("ElapsedSeconds", scope, true).Data = stopWatch.Elapsed.TotalSeconds;
+      return null;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Operators.Stopwatch/Stopwatch.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Stopwatch/Stopwatch.cs	(revision 445)
+++ trunk/sources/HeuristicLab.Operators.Stopwatch/Stopwatch.cs	(revision 445)
@@ -0,0 +1,90 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using System.Diagnostics;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Operators.Stopwatch {
+  public class Stopwatch : ItemBase {
+    private System.Diagnostics.Stopwatch stopwatch;
+    private long elapsedTicks;
+    private bool running;
+
+    public Stopwatch() {
+      stopwatch = new System.Diagnostics.Stopwatch();
+      elapsedTicks = 0;
+      running = false;
+    }
+
+    public void Start() {
+      stopwatch.Start();
+      running = true;
+    }
+
+    public void Stop() {
+      stopwatch.Stop();
+      elapsedTicks = stopwatch.ElapsedTicks;
+      stopwatch.Reset();
+      running = false;
+    }
+
+    public long ElapsedTicks {
+      get {
+        return elapsedTicks + stopwatch.ElapsedTicks;
+      }
+    }
+
+    public TimeSpan Elapsed {
+      get {
+        return TimeSpan.FromTicks(elapsedTicks).Add(stopwatch.Elapsed);
+      }
+    }
+
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      Stopwatch clone = (Stopwatch)base.Clone(clonedObjects);
+      if(running) clone.Start();
+      clone.elapsedTicks = elapsedTicks;
+      return clone;
+    }
+
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid,IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      XmlAttribute runningAttr = document.CreateAttribute("Running");
+      runningAttr.Value = running.ToString();
+      node.Attributes.Append(runningAttr);
+      XmlAttribute elapsedTicksAttr = document.CreateAttribute("ElapsedTicks");
+      elapsedTicksAttr.Value = elapsedTicks.ToString();
+      node.Attributes.Append(elapsedTicksAttr);
+      return node;
+    }
+    public override void Populate(XmlNode node, IDictionary<Guid,IStorable> restoredObjects) {
+      elapsedTicks = long.Parse(node.Attributes["ElapsedTicks"].Value);
+      running = bool.Parse(node.Attributes["Running"].Value);
+      if(running) stopwatch.Start();
+      base.Populate(node, restoredObjects);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.sln
===================================================================
--- trunk/sources/HeuristicLab.sln	(revision 444)
+++ trunk/sources/HeuristicLab.sln	(revision 445)
@@ -83,4 +83,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Core", "HeuristicLab.CEDMA.Core\HeuristicLab.CEDMA.Core.csproj", "{C27DDF6C-84DF-45EF-B82F-57A28DD51166}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.Stopwatch", "HeuristicLab.Operators.Stopwatch\HeuristicLab.Operators.Stopwatch.csproj", "{39DEF061-8261-43DB-8B3B-C7555251FF77}"
 EndProject
 Global
@@ -242,4 +244,8 @@
 		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.Build.0 = Release|Any CPU
+		{39DEF061-8261-43DB-8B3B-C7555251FF77}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39DEF061-8261-43DB-8B3B-C7555251FF77}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39DEF061-8261-43DB-8B3B-C7555251FF77}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{39DEF061-8261-43DB-8B3B-C7555251FF77}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 444)
+++ trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 445)
@@ -28,4 +28,5 @@
 copy "..\..\..\HeuristicLab.Operators\bin\%1\HeuristicLab.Operators.dll" .\plugins
 copy "..\..\..\HeuristicLab.Operators.Programmable\bin\%1\HeuristicLab.Operators.Programmable.dll" .\plugins
+copy "..\..\..\HeuristicLab.Operators.Stopwatch\bin\%1\HeuristicLab.Operators.Stopwatch.dll" .\plugins
 copy "..\..\..\HeuristicLab.OptimizationFrontend\bin\%1\HeuristicLab.OptimizationFrontend.dll" .\plugins
 copy "..\..\..\HeuristicLab.Permutation\bin\%1\HeuristicLab.Permutation.dll" .\plugins